=begin

    Copyright (C) 2009, 2010

    Alberto Ortega Llamas
    admin[at]pentbox[dot]net

    PenTBox (Penetration Testing Box)

    This file is part of PenTBox.

    PenTBox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PenTBox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PenTBox.  If not, see <http://www.gnu.org/licenses/>.

=end

# Hash Password Cracker (MD5, SHA1, SHA256, SHA512).
#

require "digest/md5"
require "digest/sha1"
require "digest/sha2"

puts ""
puts "// Hash Password Cracker (MD5, SHA1, SHA256, SHA512) //"
puts ""
puts " Insert hash to crack."
puts ""
print "   -> "
hash = gets.chomp
hash = hash.downcase
puts ""
puts " And now, insert type of hash that you entered."
puts ""
puts "1 - MD5"
puts "2 - SHA1"
puts "3 - SHA256"
puts "4 - SHA512"
puts ""
print "  -> "
type = gets.chomp
puts ""
puts " Ok, the last step. Enter method to crack."
puts ""
puts "1 - Numbers bruteforce"
puts "2 - Diccionary - NOT IMPLEMENTED YET"
puts ""
print "  -> "
how = gets.chomp

def cracknum(algorit, hash)
	thread1 = Thread.new do # One thread to compare possibilities.
		$cracked = "n"
		$num = 0
		try = rand(999)
		while try != hash
			$num += 1
			try = algorit.hexdigest($num.to_s)
		end
		$cracked = "y"
		thread1.kill
	end
	while $cracked == "n" # And the principal thread to show the status.
		puts "Trying " + $num.to_s
		sleep(0.02)
	end
	puts ""
	puts "I feel lucky, why can be?"
	puts ""
	puts ""
	puts "Cracked password -> " + $num.to_s
	puts ""
end

case type
	when "1"
		case how
			when "1"
				cracknum(Digest::MD5, hash)
			when "2"
				puts ""
				puts "NOT IMPLEMENTED YET, SORRY."
				puts ""
			else
				puts ""
				puts "Invalid method to crack."
				puts ""
			end
	when "2"
		case how
			when "1"
				cracknum(Digest::SHA1, hash)
			when "2"
				puts ""
				puts "NOT IMPLEMENTED YET, SORRY."
				puts ""
			else
				puts ""
				puts "Invalid method to crack."
				puts ""
			end
	when "3"
		case how
			when "1"
				cracknum(Digest::SHA256, hash)
			when "2"
				puts ""
				puts "NOT IMPLEMENTED YET, SORRY."
				puts ""
			else
				puts ""
				puts "Invalid method to crack."
				puts ""
			end
	when "4"
		case how
			when "1"
				cracknum(Digest::SHA512, hash)
			when "2"
				puts ""
				puts "NOT IMPLEMENTED YET, SORRY."
				puts ""
			else
				puts ""
				puts "Invalid method to crack."
				puts ""
			end
	else
		puts ""
		puts "Invalid hash type."
		puts ""

end
