=begin

    Copyright (C) 2010

    Alberto Ortega Llamas
    admin[at]pentbox[dot]net

    PenTBox (Penetration Testing Box)

    This file is part of PenTBox.

    PenTBox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PenTBox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PenTBox.  If not, see <http://www.gnu.org/licenses/>.

=end

# Fuzzer to find vulnerabilities.
#

require "socket"
require "timeout"

puts ""
puts "// Fuzzer //"
puts ""
puts "Supported protocols -> [HTTP, FTP]"
puts ""
puts " Insert host."
puts ""
print "   -> "
$host = gets.chomp
puts ""
puts " Insert port."
puts ""
print "   -> "
$port = gets.chomp
puts ""
puts " Select protocol."
puts ""
puts "1- HTTP"
puts "2- FTP"
puts ""
print "   -> "
protocol = gets.chomp

def fuzz_buff_http(title, part1, part2) # Fuzzing Buffer Overflow in HTTP function.
	$buffer = "A" # Buffer value now is A.
	cont = 0
	anumber = 1
	puts ""
	print title # Print what type of fuzz is doing.
	while (cont <= 11)
		sleep(0.25)
		cont += 1
		$buffer = "#{$buffer}#{$buffer}" # Buffer value grows.
		send = "#{part1}#{$buffer}#{part2}" # The packet built with part1, buffer and part2.
		begin
			Timeout::timeout(20) do
				begin
					socket = TCPSocket.new($host, $port)
				rescue
					# If there is no socket, probably a DoS has being caused.
					puts ""
					puts ""
					puts "   Impossible to connect."
					puts "   Host may be DoSed. Possible Exploit?"
					puts ""
					puts "   Packet #{title}#{anumber.to_s}A"
					puts ""
					exit
				end
				socket.write(send)
				socket.close
			end
		rescue Timeout::Error
			puts ""
			puts ""
			puts "   Connection timeout."
			puts "   Host may be DoSed. Possible Exploit?"
			puts ""
			puts "   Packet #{title}#{anumber.to_s}A"
			puts ""
			exit
		end
		anumber = anumber + anumber # This is to print what size of buffer has being sent.
		print "#{anumber.to_s}A "
	end
	print "- OK"
	puts ""
end

begin
	socket = TCPSocket.new($host, $port)
rescue
	puts ""
	puts "Impossible to connect."
	puts ""
	exit
end
socket.close

# Here the functions are launched, if you want to omit one of then, comment it.
case protocol
	when "1"
		puts ""
		puts "  Testing Buffer Overflow"
		puts "  -----------------------"
		fuzz_buff_http("   HEAD [MALFORMED] HTTP/1.0 -> ", "HEAD ", " HTTP/1.0\r\n\r\n")
		fuzz_buff_http("   HEAD / [MALFORMED] -> ", "HEAD / ", "\r\n\r\n")
		fuzz_buff_http("   GET [MALFORMED] HTTP/1.0 -> ", "GET ", " HTTP/1.0\r\n\r\n")
		fuzz_buff_http("   GET / [MALFORMED] -> ", "GET / ", "\r\n\r\n")
		fuzz_buff_http("   POST [MALFORMED] HTTP/1.0 -> ", "POST ", " HTTP/1.0\r\n\r\n")
		fuzz_buff_http("   POST / [MALFORMED] -> ", "POST / ", "\r\n\r\n")
		fuzz_buff_http("   GET / HTTP/[MALFORMED] -> ", "GET / HTTP/", "\r\n\r\n")
		fuzz_buff_http("   GET / [MALFORMED]/1.0 -> ", "GET / ", "/1.0\r\n\r\n")
		fuzz_buff_http("   GET / [MALFORMED]/1.1 -> ", "GET / ", "/1.1\r\n\r\n")
		fuzz_buff_http("   User-Agent: [MALFORMED] -> ", "GET / HTTP/1.0\r\nUser-Agent: ", "\r\n\r\n")
		fuzz_buff_http("   Host: [MALFORMED] -> ", "GET / HTTP/1.0\r\nHost: ", "\r\n\r\n")
		fuzz_buff_http("   Connection: [MALFORMED] -> ", "GET / HTTP/1.0\r\nConnection: ", "\r\n\r\n")
		fuzz_buff_http("   Referer: [MALFORMED] -> ", "GET / HTTP/1.0\r\nReferer: ", "\r\n\r\n")
		fuzz_buff_http("   Authorization: [MALFORMED] -> ", "GET / HTTP/1.0\r\nAuthorization: ", "\r\n\r\n")
		fuzz_buff_http("   Cookie: [MALFORMED] -> ", "GET / HTTP/1.0\r\nCookie: ", "\r\n\r\n")
		fuzz_buff_http("   Accept: [MALFORMED] -> ", "GET / HTTP/1.0\r\nAccept: ", "\r\n\r\n")
		fuzz_buff_http("   Accept-Encoding: [MALFORMED] -> ", "GET / HTTP/1.0\r\nAccept-Encoding: ", "\r\n\r\n")
		fuzz_buff_http("   Accept-Language: [MALFORMED] -> ", "GET / HTTP/1.0\r\nAccept-Language: ", "\r\n\r\n")
		fuzz_buff_http("   Accept-Charset: [MALFORMED] -> ", "GET / HTTP/1.0\r\nAccept-Charset: ", "\r\n\r\n")
		fuzz_buff_http("   Accept-Ranges: [MALFORMED] -> ", "GET / HTTP/1.0\r\nAccept-Ranges: ", "\r\n\r\n")
		fuzz_buff_http("   Content-Length: [MALFORMED] -> ", "GET / HTTP/1.0\r\nContent-Length: ", "\r\n\r\n")
		fuzz_buff_http("   Content-Type: [MALFORMED] -> ", "GET / HTTP/1.0\r\nContent-Type: ", "\r\n\r\n")
		fuzz_buff_http("   Cache-Control: [MALFORMED] -> ", "GET / HTTP/1.0\r\nCache-Control: ", "\r\n\r\n")
		fuzz_buff_http("   Date: [MALFORMED] -> ", "GET / HTTP/1.0\r\nDate: ", "\r\n\r\n")
		fuzz_buff_http("   From: [MALFORMED] -> ", "GET / HTTP/1.0\r\nFrom: ", "\r\n\r\n")
		fuzz_buff_http("   Charge-To: [MALFORMED] -> ", "GET / HTTP/1.0\r\nCharge-To: ", "\r\n\r\n")
		fuzz_buff_http("   ChargeTo: [MALFORMED] -> ", "GET / HTTP/1.0\r\nChargeTo: ", "\r\n\r\n")
		fuzz_buff_http("   If-Match: [MALFORMED] -> ", "GET / HTTP/1.0\r\nIf-Match: ", "\r\n\r\n")
		fuzz_buff_http("   If-Modified-Since: [MALFORMED] -> ", "GET / HTTP/1.0\r\nIf-Modified-Since: ", "\r\n\r\n")
		fuzz_buff_http("   If-Unmodified-Since: [MALFORMED] -> ", "GET / HTTP/1.0\r\nIf-Unmodified-Since: ", "\r\n\r\n")
		fuzz_buff_http("   If-None-Match: [MALFORMED] -> ", "GET / HTTP/1.0\r\nIf-None-Match: ", "\r\n\r\n")
		fuzz_buff_http("   If-Range: [MALFORMED] -> ", "GET / HTTP/1.0\r\nIf-Range: ", "\r\n\r\n")
		fuzz_buff_http("   Max-Forwards: [MALFORMED] -> ", "GET / HTTP/1.0\r\nMax-Forwards: ", "\r\n\r\n")
		fuzz_buff_http("   Pragma: [MALFORMED] -> ", "GET / HTTP/1.0\r\nPragma: ", "\r\n\r\n")
		fuzz_buff_http("   Proxy-Authorization: [MALFORMED] -> ", "GET / HTTP/1.0\r\nProxy-Authorization: ", "\r\n\r\n")
		fuzz_buff_http("   Range: [MALFORMED] -> ", "GET / HTTP/1.0\r\nRange: ", "\r\n\r\n")
		fuzz_buff_http("   TE: [MALFORMED] -> ", "GET / HTTP/1.0\r\nTE: ", "\r\n\r\n")
		fuzz_buff_http("   Upgrade: [MALFORMED] -> ", "GET / HTTP/1.0\r\nUpgrade: ", "\r\n\r\n")
		fuzz_buff_http("   Via: [MALFORMED] -> ", "GET / HTTP/1.0\r\nVia: ", "\r\n\r\n")
		fuzz_buff_http("   Warn: [MALFORMED] -> ", "GET / HTTP/1.0\r\nWarn: ", "\r\n\r\n")
		puts ""
	when "2"
		puts ""
		puts "  Testing Buffer Overflow"
		puts "  -----------------------"
		# As you can see, FTP is not developed at all ...
		fuzz_buff_http("   AUTH [MALFORMED] -> ", "AUTH ", "\r\n")
		fuzz_buff_http("   [MALFORMED] SSL -> ", "", " SSL\r\n")
		fuzz_buff_http("   [MALFORMED] TLS -> ", "", " TLS\r\n")
		fuzz_buff_http("   USER [MALFORMED] -> ", "USER ", "\r\n")
		fuzz_buff_http("   PASS [MALFORMED] -> ", "PASS ", "\r\n")
		puts ""
	else
		puts ""
		puts "Incorrect protocol."
		puts ""
end
