=begin

    Copyright (C) 2009, 2010

    Alberto Ortega Llamas
    admin[at]pentbox[dot]net

    PenTBox (Penetration Testing Box)

    This file is part of PenTBox.

    PenTBox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PenTBox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PenTBox.  If not, see <http://www.gnu.org/licenses/>.

=end

# Secure IM Client. More info in the comments of the program.
#

require "socket"
#require "digest/sha2"
require "base64"

puts ""
puts "// Secure IM Client //"
puts ""
puts "WARNING: You should run PenTBox with root privileges when you are the server."
puts ""
puts " Who are you?"
puts ""
puts "1- Client"
puts "2- Server"
puts ""
puts "3 - About Secure IM Client"
puts ""
print "   -> "
whoare = gets.chomp

=begin # Probably Key generation method for future AES/Other Encryption.

# Client
key = rand(5000)
key_hash = Digest::SHA512.hexdigest(key.to_s)

5.times do
	key_hash = Base64.encode64(key_hash.to_s)
end

key_to_send = key_hash


# Server
5.times do
	key_to_send = Base64.decode64(key_to_send.to_s)
end

def crackhash(key_to_send)
		num = 0
		try = 5001
		while try != key_to_send
			num += 1
			try = Digest::SHA512.hexdigest(num.to_s)
		end
end

key = num

=end

=begin # How Base64 encoding/decoding works in the communication.

Client and server encodes/decodes the traffic in a simple Base64 based mode.

1º Server makes a random number (4 - 8).

2º Server sends this number to client. The traffic will be encoded and reversed this number of times.

3º Traffic is encoded and reversed, encoded and reversed, encoded and reversed ... In the other way, traffic is reversed and decoded, reversed and decoded, reversed and decoded ...

=end

def client_connection_b64pb(ip, port) # CLIENT
	begin
		socket = TCPSocket.new(ip, port)
		if socket
			puts "Connecting ..."
			pbversion_mode = "1.1_b64pb" # PenTBox version and mode.
			pbversion_mode_recv = socket.recv(100) # Recives version and mode from server.
			sleep(0.1)
			if pbversion_mode != pbversion_mode_recv # Verifies if server and client are using compatible versions and the same encryption mode.
				connection = "incorrect"
				socket.write(connection) # Sends incorrect version or mode to server.
				socket.close
				puts ""
				puts " Error: Server and client are using incompatible versions or different encryption mode."
				puts ""
			else
				connection = "correct"
				socket.write(connection) # Sends correct version and mode to server.
				sleep(0.1)
				base64_num = socket.recv(15) # Recives number of times to encode messages from server.
				puts "Connection established."
				puts "Traffic will be encoded #{base64_num.to_s} times."
				puts ""
				Thread.new do # New Thread where client recives and decodes messages from server.
					loop do
						mess = socket.recv(10000) # Encoded message from server.
						base64_num.to_i.times do # Decodification step.
							mess = mess.reverse
							mess = Base64.decode64(mess)
						end
						puts mess # And puts it in the screen.
						puts ""
					end
				end
				loop do # Principal thread to send encoded messages to server.
					text = "Client say: " + gets.chomp
					puts text
					puts ""
					base64_num.to_i.times do
						text = Base64.encode64(text)
						text = text.reverse
					end
					socket.write(text)
				end
			end
		end
	rescue
		puts ""
		puts "Connection problem."
		puts ""
	end
end

def server_config_b64pb(port) # SERVER
	newclients = 1
	begin
		tcpserver = TCPServer.new("", port)
		if tcpserver
			base64_num = rand(5) # Number of times to encode messages. Make a random number from 4 to 8.
			base64_num += 4
			puts ""
			puts " Secure IM Client server activated. Waiting for connection on port #{port.to_s}."
			puts " Traffic will be encoded #{base64_num.to_s} times."
			puts ""
			loop do
				socket = tcpserver.accept
				sleep(0.5) # It is to solve possible DoS Attacks.
				if socket
					Thread.new do # New Thread in the server where run the IM room.
						if newclients == 1 # This is to accept only 1 client for session. This is a private IM room!
							newclients = 0
							puts "Connecting ..."
							pbversion_mode = "1.1_b64pb" # PenTBox version and mode.
							socket.write(pbversion_mode) # Sends version and mode to client.
							sleep(0.1)
							connection = socket.recv(50) # Recives from client if server and client are using compatible versions and the same encryption mode.
							sleep(0.1)
							if connection != "correct" # Recives incorrect version or mode from client.
								socket.close
								puts ""
								puts " Error: Server and client are using incompatible versions or different encryption mode."
								puts ""
							else # Recives correct version and mode from client.
								socket.write(base64_num) # Sends number of times to encode messages to client.
								puts "Connection established."
								puts "Traffic will be encoded #{base64_num.to_s} times."
								puts ""
								Thread.new do # New Thread where server recives and decodes messages from client.
									loop do
										mess = socket.recv(10000) # Encoded message from client.
										base64_num.to_i.times do # Decodification step.
											mess = mess.reverse
											mess = Base64.decode64(mess)
										end
										puts mess # And puts it in the screen.
										puts ""
									end
								end
								loop do # Principal thread to send encoded messages to client.
									text = "Server say: " + gets.chomp
									puts text
									puts ""
									base64_num.to_i.times do
										text = Base64.encode64(text)
										text = text.reverse
									end
									socket.write(text)
								end
							end
						else
							socket.close
						end
					end
				end
			end
		end
	rescue Errno::EACCES
		puts ""
		puts " Error: Secure IM Client requires root privileges!!"
		puts ""
	rescue Errno::EADDRINUSE
		puts ""
		puts " Error: Port in use."
		puts ""
	rescue
		puts ""
		puts " Unknown error."
		puts ""
	end
end

case whoare
	when "1"
		puts ""
		puts " Insert host to connect."
		puts ""
		print "   -> "
		ip = gets.chomp
		puts ""
		client_connection_b64pb(ip, 6817)
	when "2"
		server_config_b64pb(6817)
	when "3"
		puts ""
		puts "// Secure IM Client //" # Description.
		puts ""
		puts " This program is a direct IM room creator between client and server,"
		puts " without Microsoft servers, or something like that."
		puts " All traffic is encoded (by the moment) with a simple Base64 based"
		puts " method, that brings you a little anti-sniffing security."
		puts " Conversations are not recorded in external servers, or in logs."
		puts ""
	else
		puts ""
		puts "Invalid option."
		puts ""
end
