=begin

    Copyright (C) 2009, 2010

    Alberto Ortega Llamas
    admin[at]pentbox[dot]net

    PenTBox (Penetration Testing Box)

    This file is part of PenTBox.

    PenTBox is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PenTBox is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PenTBox.  If not, see <http://www.gnu.org/licenses/>.

=end

# A simple scanner that connects sockets to see if the port is open.
#

require "socket"
require "timeout"

puts ""
puts "// UltraFast Port scanner //"
puts "     Only for LAN or SuperFast networks."
puts ""
puts " Insert host to scan."
puts ""
print "   -> "
$host = gets.chomp

$down = "y"

def scanrang(initialport, finalport, socketname, thread, sleeptime)
	thread = Thread.new do
		sleep(sleeptime)
		begin
			Timeout::timeout(30) do
				while initialport != finalport
					initialport += 1
					begin
						socketname = TCPSocket.new($host, initialport)
						if socketname
							$down = "n"
							puts ""
							puts " Open port -> " + initialport.to_s
						end
						socketname.close
					rescue
					end
				end
				if $down != "n"
					$down = "closed"
				end
			end
		rescue Timeout::Error
		end
	end
end

puts ""
puts " OPEN PORTS"

scanrang(0, 501, "socket1", "thread1", 0)
scanrang(501, 1001, "socket2", "thread2", 1)
scanrang(1001, 1501, "socket3", "thread3", 2)
scanrang(1501, 2001, "socket4", "thread4", 3)
scanrang(2001, 2501, "socket5", "thread5", 4)
scanrang(2501, 3001, "socket6", "thread6", 5)
scanrang(3001, 3501, "socket7", "thread7", 6)
scanrang(3501, 4001, "socket8", "thread8", 7)
scanrang(4001, 4501, "socket9", "thread9", 8)
#scanrang(4501, 5000, "socket10", "thread10", 12)

# I put the last range without thread to not finish the program.

begin
	sleep(12)
	Timeout::timeout(30) do
		initialport = 4501
		finalport = 5000
		while initialport != finalport
			initialport += 1
			begin
				socket10 = TCPSocket.new($host, initialport)
				if socket10
					$down = "n"
					puts ""
					puts " Open port -> " + initialport.to_s
				end
				socket10.close
			rescue
			end
		end
		if $down != "n"
			$down = "closed"
		end
	end
rescue Timeout::Error
end

if $down == "y"
	puts ""
	puts " Host down, or invalid IP."
	puts " (Or not enough velocity in the network)."
end
if $down == "closed"
	puts ""
	puts " All ports closed or filtered."
end

puts ""
puts " -- Scan finished --"
puts ""
